/* 
   COPYRIGHT 2005 KRUPCZAK.ORG, LLC.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA
 
   For more information, visit:
   http://www.krupczak.org/
*/

/* file - pluginexport.h */
/* rdk@krupczak.org */

/* 
   Exported plugin definitions, APIs, exposed symbols, etc. 
   to be included in plugin source code.  Do not include this file in 
   agent code!! 
*/

/* ************************************************************* */
/* exported symbols, functions, etc. */

int xmpGetAgentDebugLevel();
float xmpGetAgentVersion();
int xmpGetAgentPort();
int xmpConvertTimeStr(time_t, char *, int);
void *xmpGetSymbolValue(char *);
int xmpConvertIpAddr(u_int, char *, int);
int xmpConvertIpV6Addr(u_char *, char *, int);
int xmpAddVar(xmpVar_t *);
int xmpRemoveVarByName(char *, char *);
u_int xmpHostnameToIpaddr(char *);
int xmpHostnameToIpv6addr(char *, void *);
int xmpIpVersionOfAddress(char *);
int xmpIpVersionOfSocket(int);
int xmpdLog(char *);

int xmpTransaction(xmpSession_t *, xmpPdu_t *, xmpPdu_t *);
int xmpPduCleanup(xmpPdu_t *);
int xmpDisconnectSession(xmpSession_t *);
int xmpAddressToHostname(char *, char *, int);
int xmpIpAddrToHostname(char *, char *, int);
int xmpGetSystemName(char *, int);
int xmpAddModule(char *, char *, char *, char *, int);
int xmpRemoveModule(char *);
int xmpCheckPeerModules(char *);
float xmpFindBinaryVersion(char *, char *);
xmpErrorStatus_t xmpSendTrap(char *, xmpPdu_t *, char *, char *, char *);
int xmpGetHomeDir(char *, int);

int xmpAddUser(char *, u_int, char *);
int xmpSessionSetAuthenUser(xmpSession_t *, char *);

#ifndef WIN32
int xmpRegisterTrapHandler(char *, int (*fptr)());
#else
int xmpRegisterTrapHandler(char *, FARPROC);
#endif

char *xmpBase64Encode(u_char *, int, int *);
u_char *xmpBase64Decode(u_char *, int, int *);

/* ************************************************************* */
