/* 
   COPYRIGHT 2008 KRUPCZAK.ORG, LLC.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA
 
   For more information, visit:
   http://www.krupczak.org/
*/

/* file - xmp_users.h */
/* rdk@krupczak.org */

/* ************************************************************* */
/* xmp authenUsers or profiles, permissions; each configured user/profile
   is kept in one of these structures */

#define XMP_ALL_OPS  0xFFFF
#define XMP_ALL_MIBS "all"
#define XMP_DEFAULT_USER  "xmpUser"

typedef struct xmpAuthenUser {

  /* name of profile/user */
  char authenUser[18];  /* max 16-chars + \0 */

  /* OR'd list of protocol operations allowed */
  u_int protocolOperations;

  /* list of comma-separated MIBs that are allowed */
  /* or keyword 'all' */
  char allowedMibs[256];

  /* usage counters for this user XXX */
  int valid;
  int invalid;

} xmpAuthenUser_t;

int validatePduPermissions(xmpSession_t *, xmpPdu_t *);
int initUsers();

/* ************************************************************* */
